<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" label-width="100px" v-loading="formLoading">
      <el-form-item label="姓名" prop="name">
        <el-input v-model="formData.name" placeholder="请输入姓名" />
      </el-form-item>
      <el-form-item label="头像" prop="avater">
        <UploadImg v-model="formData.avater" directory="custom_service_avatar" />
      </el-form-item>
      <el-form-item label="简介" prop="description">
        <el-input v-model="formData.description" placeholder="请输入简介" maxlength="30" show-word-limit />
      </el-form-item>
      <el-form-item label="微信二维码" prop="concat">
        <UploadImg v-model="formData.concat" directory="custom_service_wechat" />
      </el-form-item>
      <el-form-item label="手机号" prop="phone">
        <el-input v-model="formData.phone" placeholder="请输入手机号" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { CustomServiceInfoApi, CustomServiceInfoVO } from '@/api/server/customserviceinfo'
import { UploadImg } from '@/components/UploadFile'

/** 客服信息 表单 */
defineOptions({ name: 'CustomServiceInfoForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  avater: undefined,
  description: undefined,
  concat: undefined,
  phone: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CustomServiceInfoApi.getCustomServiceInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CustomServiceInfoVO
    if (formType.value === 'create') {
      await CustomServiceInfoApi.createCustomServiceInfo(data)
      message.success(t('common.createSuccess'))
    } else {
      await CustomServiceInfoApi.updateCustomServiceInfo(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    avater: undefined,
    description: undefined,
    concat: undefined,
    phone: undefined
  }
  formRef.value?.resetFields()
}
</script>